Index: branches/2015/dev_r5171_CNRS_LIM3_seaicebgc/NEMOGCM/CONFIG/SHARED/namelist_pisces_ref
===================================================================
--- branches/2015/dev_r5171_CNRS_LIM3_seaicebgc/NEMOGCM/CONFIG/SHARED/namelist_pisces_ref	(revision 5357)
+++ branches/2015/dev_r5171_CNRS_LIM3_seaicebgc/NEMOGCM/CONFIG/SHARED/namelist_pisces_ref	(revision 5358)
@@ -207,4 +207,45 @@
 /
 !'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
+&nampisice      !  Prescribed sea ice tracers
+!,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
+! constant ocean tracer concentrations are defined in trcice_pisces.F90 (Global, Arctic, Antarctic and Baltic)
+! trc_ice_ratio     * betw 0 and 1: prescribed ice/ocean tracer concentration ratio
+!                   * -1 => the ice-ocean tracer concentration ratio follows the 
+!                           ice-ocean salinity ratio
+!                   * -2 => tracer concentration in sea ice is prescribed and 
+!                           trc_ice_prescr is used
+! trc_ice_prescr    * prescribed tracer concentration. used only if 
+!                     trc_ice_ratio = -2. equals -99 if not used.
+! cn_trc_o          * 'GL' use global ocean values making the Baltic distinction only
+!                     'AA' use specific Arctic/Antarctic/Baltic values
+!,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
+!    sn_tri_ ! trc_ice_ratio ! trc_ice_prescr !     cn_trc_o
+   sn_tri_dic =           -1.,           -99.,          'AA'
+   sn_tri_doc =            0.,           -99.,          'AA'
+   sn_tri_tal =           -1.,           -99.,          'AA'
+   sn_tri_oxy =           -1.,           -99.,          'AA'
+   sn_tri_cal =            0.,           -99.,          'AA'
+   sn_tri_po4 =           -1.,           -99.,          'AA'
+   sn_tri_poc =            0.,           -99.,          'AA'
+   sn_tri_goc =            0.,           -99.,          'AA'
+   sn_tri_bfe =            0.,           -99.,          'AA'
+   sn_tri_num =            0.,           -99.,          'AA'
+   sn_tri_sil =           -1.,           -99.,          'AA'
+   sn_tri_dsi =            0.,           -99.,          'AA'
+   sn_tri_gsi =            0.,           -99.,          'AA'
+   sn_tri_phy =            0.,           -99.,          'AA'
+   sn_tri_dia =            0.,           -99.,          'AA'
+   sn_tri_zoo =            0.,           -99.,          'AA'
+   sn_tri_mes =            0.,           -99.,          'AA'
+   sn_tri_fer =           -2.,          15E-9,          'AA'
+   sn_tri_sfe =            0.,           -99.,          'AA'
+   sn_tri_dfe =            0.,           -99.,          'AA'
+   sn_tri_nfe =            0.,           -99.,          'AA'
+   sn_tri_nch =            0.,           -99.,          'AA'
+   sn_tri_dch =            0.,           -99.,          'AA'
+   sn_tri_no3 =           -1.,           -99.,          'AA'
+   sn_tri_nh4 =            1.,           -99.,          'AA'
+/
+!'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
 &nampiskrp     !   Kriest parameterization : parameters     "key_kriest"
 !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
@@ -371,43 +412,2 @@
    pisdiabio(17)  = 'SEDNO3' , 'NO3 remineralization from SED',  'mmole/m3/s'
 /
-!'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
-&nampisice      !  Prescribed sea ice tracers
-!,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
-! constant ocean tracer concentrations are defined in trcice_pisces.F90 (Global, Arctic, Antarctic and Baltic)
-! trc_ice_ratio     * betw 0 and 1: prescribed ice/ocean tracer concentration ratio
-!                   * -1 => the ice-ocean tracer concentration ratio follows the 
-!                           ice-ocean salinity ratio
-!                   * -2 => tracer concentration in sea ice is prescribed and 
-!                           trc_ice_prescr is used
-! trc_ice_prescr    * prescribed tracer concentration. used only if 
-!                     trc_ice_ratio = -2. equals -99 if not used.
-! cn_trc_o          * 'GL' use global ocean values making the Baltic distinction only
-!                     'AA' use specific Arctic/Antarctic/Baltic values
-!,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
-!    sn_tri_ ! trc_ice_ratio ! trc_ice_prescr !     cn_trc_o
-   sn_tri_dic =           -1.,           -99.,          'AA'
-   sn_tri_doc =            0.,           -99.,          'AA'
-   sn_tri_tal =           -1.,           -99.,          'AA'
-   sn_tri_oxy =           -1.,           -99.,          'AA'
-   sn_tri_cal =            0.,           -99.,          'AA'
-   sn_tri_po4 =           -1.,           -99.,          'AA'
-   sn_tri_poc =            0.,           -99.,          'AA'
-   sn_tri_goc =            0.,           -99.,          'AA'
-   sn_tri_bfe =            0.,           -99.,          'AA'
-   sn_tri_num =            0.,           -99.,          'AA'
-   sn_tri_sil =           -1.,           -99.,          'AA'
-   sn_tri_dsi =            0.,           -99.,          'AA'
-   sn_tri_gsi =            0.,           -99.,          'AA'
-   sn_tri_phy =            0.,           -99.,          'AA'
-   sn_tri_dia =            0.,           -99.,          'AA'
-   sn_tri_zoo =            0.,           -99.,          'AA'
-   sn_tri_mes =            0.,           -99.,          'AA'
-   sn_tri_fer =           -2.,          15E-9,          'AA'
-   sn_tri_sfe =            0.,           -99.,          'AA'
-   sn_tri_dfe =            0.,           -99.,          'AA'
-   sn_tri_nfe =            0.,           -99.,          'AA'
-   sn_tri_nch =            0.,           -99.,          'AA'
-   sn_tri_dch =            0.,           -99.,          'AA'
-   sn_tri_no3 =           -1.,           -99.,          'AA'
-   sn_tri_nh4 =            1.,           -99.,          'AA'
-/
Index: branches/2015/dev_r5171_CNRS_LIM3_seaicebgc/NEMOGCM/CONFIG/SHARED/namelist_top_ref
===================================================================
--- branches/2015/dev_r5171_CNRS_LIM3_seaicebgc/NEMOGCM/CONFIG/SHARED/namelist_top_ref	(revision 5357)
+++ branches/2015/dev_r5171_CNRS_LIM3_seaicebgc/NEMOGCM/CONFIG/SHARED/namelist_top_ref	(revision 5358)
@@ -83,5 +83,5 @@
 &namtrc_ice       !    Representation of sea ice growth & melt effects
 !-----------------------------------------------------------------------
-   nn_ice_tr   =  1        !  tracer concentration in sea ice 
+   nn_ice_tr   =  -1        !  tracer concentration in sea ice 
                            !    =-1 (no vvl: identical cc in ice and ocean / vvl: cc_ice = 0)
                            !    = 0 (no vvl: cc_ice = zero / vvl: cc_ice = )