Index: branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/AMM12/EXP00/namelist_cfg
===================================================================
--- branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/AMM12/EXP00/namelist_cfg	(revision 5786)
+++ branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/AMM12/EXP00/namelist_cfg	(revision 5827)
@@ -336,5 +336,4 @@
    ln_dynvor_een = .true.  !  energy & enstrophy scheme
       nn_een_e3f = 1             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
-   ln_dynvor_msk = .false. !  vorticity multiplied by fmask (=T) or not (=F) (all vorticity schemes)
 /
 !-----------------------------------------------------------------------
Index: branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/GYRE/EXP00/namelist_cfg
===================================================================
--- branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/GYRE/EXP00/namelist_cfg	(revision 5786)
+++ branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/GYRE/EXP00/namelist_cfg	(revision 5827)
@@ -278,5 +278,4 @@
    ln_dynvor_een = .false. !  energy & enstrophy scheme
       nn_een_e3f = 1             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
-   ln_dynvor_msk = .true.  !  vorticity multiplied by fmask (=T) or not (=F) (all vorticity schemes)
 /
 !-----------------------------------------------------------------------
Index: branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/GYRE_BFM/EXP00/namelist_cfg
===================================================================
--- branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/GYRE_BFM/EXP00/namelist_cfg	(revision 5786)
+++ branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/GYRE_BFM/EXP00/namelist_cfg	(revision 5827)
@@ -279,5 +279,4 @@
 !-----------------------------------------------------------------------
    ln_dynvor_ene = .true.  !  enstrophy conserving scheme
-   ln_dynvor_msk = .true.  !  vorticity multiplied by fmask (=T) or not (=F) (all vorticity schemes)
 /
 !-----------------------------------------------------------------------
Index: branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/GYRE_PISCES/EXP00/namelist_cfg
===================================================================
--- branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/GYRE_PISCES/EXP00/namelist_cfg	(revision 5786)
+++ branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/GYRE_PISCES/EXP00/namelist_cfg	(revision 5827)
@@ -198,5 +198,4 @@
    ln_dynvor_een = .false. !  energy & enstrophy scheme
       nn_een_e3f = 1             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
-   ln_dynvor_msk = .false. !  vorticity multiplied by fmask (=T) or not (=F) (all vorticity schemes)
 /
 !-----------------------------------------------------------------------
Index: branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist_cfg
===================================================================
--- branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist_cfg	(revision 5786)
+++ branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist_cfg	(revision 5827)
@@ -182,5 +182,4 @@
    ln_dynvor_een = .true.  !  energy & enstrophy scheme
       nn_een_e3f = 1             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
-   ln_dynvor_msk = .true. !  vorticity multiplied by fmask (=T) or not (=F) (all vorticity schemes)
 /
 !-----------------------------------------------------------------------
Index: branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/namelist_cfg
===================================================================
--- branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/namelist_cfg	(revision 5786)
+++ branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/namelist_cfg	(revision 5827)
@@ -181,5 +181,4 @@
    ln_dynvor_een = .true.  !  energy & enstrophy scheme
       nn_een_e3f = 0             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
-   ln_dynvor_msk = .true. !  vorticity multiplied by fmask (=T) or not (=F) (all vorticity schemes)
 /
 !-----------------------------------------------------------------------
Index: branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/ORCA2_LIM_CFC_C14b/EXP00/namelist_cfg
===================================================================
--- branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/ORCA2_LIM_CFC_C14b/EXP00/namelist_cfg	(revision 5786)
+++ branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/ORCA2_LIM_CFC_C14b/EXP00/namelist_cfg	(revision 5827)
@@ -242,5 +242,4 @@
    ln_dynvor_een = .true.  !  energy & enstrophy scheme
       nn_een_e3f = 1             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
-   ln_dynvor_msk = .false. !  vorticity multiplied by fmask (=T) or not (=F) (all vorticity schemes)
 /
 !-----------------------------------------------------------------------
Index: branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/namelist_cfg
===================================================================
--- branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/namelist_cfg	(revision 5786)
+++ branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/namelist_cfg	(revision 5827)
@@ -182,5 +182,4 @@
    ln_dynvor_een = .true.  !  energy & enstrophy scheme
       nn_een_e3f = 0             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
-   ln_dynvor_msk = .true. !  vorticity multiplied by fmask (=T) or not (=F) (all vorticity schemes)
 /
 !-----------------------------------------------------------------------
Index: branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/SHARED/namelist_ref
===================================================================
--- branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/SHARED/namelist_ref	(revision 5786)
+++ branches/2015/dev_r5721_CNRS9_NOC3_LDF/NEMOGCM/CONFIG/SHARED/namelist_ref	(revision 5827)
@@ -852,5 +852,5 @@
    ln_dynvor_een = .false. !  energy & enstrophy scheme
       nn_een_e3f = 1             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
-   ln_dynvor_msk = .false. !  vorticity multiplied by fmask (=T) or not (=F) (all vorticity schemes)
+   ln_dynvor_msk = .false. !  vorticity multiplied by fmask (=T) or not (=F) (all vorticity schemes)  ! PLEASE DO NOT USE
 /
 !-----------------------------------------------------------------------